<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Observer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">Observer.java</span></div><h1>Observer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.InetSocketAddress;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.server.ObserverBean;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * Observers are peers that do not take part in the atomic broadcast protocol.
 * Instead, they are informed of successful proposals by the Leader. Observers
 * therefore naturally act as a relay point for publishing the proposal stream
 * and can relieve Followers of some of the connection load. Observers may
 * submit proposals, but do not vote in their acceptance. 
 *
 * See ZOOKEEPER-368 for a discussion of this feature. 
 */
public class Observer extends Learner{      

<span class="fc" id="L43">    Observer(QuorumPeer self,ObserverZooKeeperServer observerZooKeeperServer) {</span>
<span class="fc" id="L44">        this.self = self;</span>
<span class="fc" id="L45">        this.zk=observerZooKeeperServer;</span>
<span class="fc" id="L46">    }</span>

    @Override
    public String toString() {
<span class="nc" id="L50">        StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L51">        sb.append(&quot;Observer &quot;).append(sock);        </span>
<span class="nc" id="L52">        sb.append(&quot; pendingRevalidationCount:&quot;)</span>
<span class="nc" id="L53">            .append(pendingRevalidations.size());</span>
<span class="nc" id="L54">        return sb.toString();</span>
    }
    
    /**
     * the main method called by the observer to observe the leader
     *
     * @throws InterruptedException
     */
    void observeLeader() throws InterruptedException {
<span class="fc" id="L63">        zk.registerJMX(new ObserverBean(this, zk), self.jmxLocalPeerBean);</span>

        try {
<span class="fc" id="L66">            InetSocketAddress addr = findLeader();</span>
<span class="fc" id="L67">            LOG.info(&quot;Observing &quot; + addr);</span>
            try {
<span class="fc" id="L69">                connectToLeader(addr);</span>
<span class="fc" id="L70">                long newLeaderZxid = registerWithLeader(Leader.OBSERVERINFO);</span>
                
<span class="fc" id="L72">                syncWithLeader(newLeaderZxid);</span>
<span class="fc" id="L73">                QuorumPacket qp = new QuorumPacket();</span>
<span class="fc bfc" id="L74" title="All 2 branches covered.">                while (self.isRunning()) {</span>
<span class="fc" id="L75">                    readPacket(qp);</span>
<span class="fc" id="L76">                    processPacket(qp);                   </span>
                }
<span class="fc" id="L78">            } catch (Exception e) {</span>
<span class="fc" id="L79">                LOG.warn(&quot;Exception when observing the leader&quot;, e);</span>
                try {
<span class="fc" id="L81">                    sock.close();</span>
<span class="nc" id="L82">                } catch (IOException e1) {</span>
<span class="nc" id="L83">                    e1.printStackTrace();</span>
<span class="fc" id="L84">                }</span>
    
                // clear pending revalidations
<span class="fc" id="L87">                pendingRevalidations.clear();</span>
<span class="fc" id="L88">            }</span>
<span class="fc" id="L89">        } finally {</span>
<span class="nc" id="L90">            zk.unregisterJMX(this);</span>
<span class="fc" id="L91">        }</span>
<span class="pc" id="L92">    }</span>
    
    /**
     * Controls the response of an observer to the receipt of a quorumpacket
     * @param qp
     * @throws IOException
     */
    protected void processPacket(QuorumPacket qp) throws IOException{
<span class="pc bpc" id="L100" title="4 of 8 branches missed.">        switch (qp.getType()) {</span>
        case Leader.PING:
<span class="fc" id="L102">            ping(qp);</span>
<span class="fc" id="L103">            break;</span>
        case Leader.PROPOSAL:
<span class="nc" id="L105">            LOG.warn(&quot;Ignoring proposal&quot;);</span>
<span class="nc" id="L106">            break;</span>
        case Leader.COMMIT:
<span class="nc" id="L108">            LOG.warn(&quot;Ignoring commit&quot;);            </span>
<span class="nc" id="L109">            break;            </span>
        case Leader.UPTODATE:
<span class="nc" id="L111">            LOG.error(&quot;Received an UPTODATE message after Observer started&quot;);</span>
<span class="nc" id="L112">            break;</span>
        case Leader.REVALIDATE:
<span class="fc" id="L114">            revalidate(qp);</span>
<span class="fc" id="L115">            break;</span>
        case Leader.SYNC:
<span class="fc" id="L117">            ((ObserverZooKeeperServer)zk).sync();</span>
<span class="fc" id="L118">            break;</span>
        case Leader.INFORM:            
<span class="fc" id="L120">            TxnHeader hdr = new TxnHeader();</span>
<span class="fc" id="L121">            Record txn = SerializeUtils.deserializeTxn(qp.getData(), hdr);</span>
<span class="fc" id="L122">            Request request = new Request (null, hdr.getClientId(), </span>
<span class="fc" id="L123">                                           hdr.getCxid(),</span>
<span class="fc" id="L124">                                           hdr.getType(), null, null);</span>
<span class="fc" id="L125">            request.txn = txn;</span>
<span class="fc" id="L126">            request.hdr = hdr;</span>
<span class="fc" id="L127">            ObserverZooKeeperServer obs = (ObserverZooKeeperServer)zk;</span>
<span class="fc" id="L128">            obs.commitRequest(request);            </span>
            break;
        }
<span class="fc" id="L131">    }</span>

    /**
     * Shutdown the Observer.
     */
    public void shutdown() {       
<span class="fc" id="L137">        LOG.info(&quot;shutdown called&quot;, new Exception(&quot;shutdown Observer&quot;));</span>
<span class="fc" id="L138">        super.shutdown();</span>
<span class="fc" id="L139">    }</span>
}

</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>